Attribute VB_Name = "runs_stops112"
'Programm zur Analyse von Partikelbahnen'
'Wolfstein et al., 2006, im Druck, Traffic

Dim col_track_nr As Integer, col_ds As Integer, col_dt As Integer
Dim track_nr(50000) As Integer
Dim ds(50000) As Single, dt(50000) As Single
Dim dv(50000) As Single
Dim i As Integer, j As Integer, i_max As Integer, j_max As Integer
Dim run_length(50000) As Single, min_length As Single, max_length As Single, mean_length As Single
Dim sum_length As Single, stabwn_length As Single, sum_lenght_2 As Single
Dim sum_ds As Single, sum_dv As Single, max_ds As Single, max_dv As Single
Dim mean_ds As Single, mean_dv As Single, stabwn_ds As Single, stabwn_dv As Single
Dim mean_ds_b As Single, mean_dv_b As Single, stabwn_ds_b As Single, stabwn_dv_b As Single
Dim m As Single, m_b As Single, k As Integer, n As Single, k_max As Integer
Dim path(50000) As Single, sum_path As Single, min_path As Single, max_path As Single, mean_path As Single, stabwn_path As Single
Dim track1 As Integer, track2 As Integer, track3 As Integer
Dim stops As Integer, min_stop As Single, max_stop As Single, sum_stops As Single, stop_time(50000) As Single, mean_stop As Single, stabwn_stop As Single
Dim m_dt As Single, min_ds As Single
Dim nullenzaehler As Integer
Dim zelle As String
Dim Zaehler As Integer
Dim a As Integer, b As Integer

Sub init()
  For i = 1 To 10000
    track_nr(i) = 0
    ds(i) = 0
    dt(i) = 0
    dv(i) = 0
    path(i) = 0
    run_length(i) = 0
    stop_time(i) = 0
  Next i
End Sub

Sub einlesen(col_track_nr, col_ds, col_dt)
 i = 2
 min_ds = 10
 zelle = "  "
 Do While zelle <> ""
    track_nr(i) = Cells(i, col_track_nr).Formula
    ds(i) = Cells(i, col_ds).Formula
    dt(i) = Cells(i, col_dt).Formula
    If dt(i) > 0 Then
       dv(i) = ds(i) / dt(i)
    End If
    If ds(i) > 0 Then
       If ds(i) < min_ds Then min_ds = ds(i)
    End If
    i = i + 1
    zelle = Cells(i, 1).Formula
 Loop
 i_max = i
End Sub



Sub runs_and_stops()  'Bestimmung der Lnge der einzelnen Bewegungen eines Kapsids (run lenght)
 j = 1
 k = 1
 i = 2
 nullenzaehler = 0
 For i = 2 To i_max - 1
    If ds(i) > 0 Then
       run_length(j) = run_length(j) + ds(i)
       If track_nr(i) <> track_nr(i + 1) And ds(i + 1) <> 0 Then j = j + 1
       If ds(i + 1) = 0 Then j = j + 1
    End If
    If ds(i) = 0 And dt(i) <> 0 Then
       nullenzaehler = nullenzaehler + 1
       stop_time(k) = stop_time(k) + dt(i)
       If track_nr(i) <> track_nr(i + 1) And ds(i + 1) = 0 Then k = k + 1
       If ds(i + 1) <> 0 Then k = k + 1
    End If
 Next i
 j_max = j
 stops = k - 1
End Sub

Sub path_length() 'Gesamtlnge der Bewegungen eines Kapsids (path length)
  k = 1
  For i = 2 To i_max
    path(k) = path(k) + ds(i)
    If track_nr(i) <> track_nr(i + 1) Then k = k + 1
  Next i
  k_max = k
  If path(k_max) = 0 Then k_max = k - 1
End Sub

Sub min_max_mean_es() 'Einzelstrecken im Zeitinterval dt - Elementarstrecken
  sum_ds = 0
  sum_dv = 0
  sum_ds_2 = 0
  sum_dv_2 = 0
  max_ds = 0
  max_dv = 0
  m = i_max - 2
  m_b = 0
  m_dt = 0
  For i = 2 To i_max
    If ds(i) > max_ds Then max_ds = ds(i)
    If dv(i) > max_dv Then max_dv = dv(i)
    
  'elementare Strecken mit 0
    sum_ds = sum_ds + ds(i)
    sum_dv = sum_dv + dv(i)
    sum_ds_2 = sum_ds_2 + (ds(i) * ds(i))
    sum_dv_2 = sum_dv_2 + (dv(i) * dv(i))
    
   If dt(i) > 0 Then m_dt = m_dt + 1
   
  'aussortieren aller dt mit dt = 0
    
  'elementare Strecken ohne ds = 0
    If ds(i) <> 0 Then
       sum_ds_b = sum_ds_b + ds(i)
       sum_dv_b = sum_dv_b + dv(i)
       sum_ds_2_b = sum_ds_2_b + (ds(i) * ds(i))
       sum_dv_2_b = sum_dv_2_b + (dv(i) * dv(i))
       m_b = m_b + 1
    End If
  Next i
  
  'elementare Strecken mit ds = 0
  
  mean_ds = sum_ds / m
  mean_dv = sum_dv / m_dt
  stabwn_ds = Sqr((m * sum_ds_2 - (sum_ds * sum_ds)) / (m * m))
  stabwn_dv = Sqr((m * sum_dv_2 - (sum_dv * sum_dv)) / (m_dt * m_dt))
  
  'elementare Strecken ohne ds = 0
  mean_ds_b = sum_ds_b / m_b
  mean_dv_b = sum_dv_b / m_b
  stabwn_ds_b = Sqr((m_b * sum_ds_2_b - (sum_ds_b * sum_ds_b)) / (m_b * m_b))
  stabwn_dv_b = Sqr((m_b * sum_dv_2_b - (sum_dv_b * sum_dv_b)) / (m_b * m_b))

End Sub

Sub min_max_mean_run_length() ' maximale, minimale und mittlere Laufstrecke aller run length
  sum_length = 0
  min_length = 100
  max_length = 0
  sum_length = 0
  sum_length_2 = 0
  n = j_max - 1
  For j = 1 To j_max - 1
    If run_length(j) > max_length Then max_length = run_length(j)
    If run_length(j) < min_length Then min_length = run_length(j)
    sum_length = sum_length + run_length(j)
    sum_length_2 = sum_length_2 + (run_length(j) * run_length(j))
    
  Next j
  mean_length = sum_length / n
  stabwn_length = Sqr((n * sum_length_2 - (sum_length * sum_length)) / (n * n))
End Sub

Sub min_max_mean_stops()
  sum_stops = 0
  min_stop = 100
  max_stop = 0
  sum_stops = 0
  sum_stops_2 = 0
  n = stops
  For j = 1 To stops
    If stop_time(j) > max_stop Then max_stop = stop_time(j)
    If stop_time(j) < min_stop Then min_stop = stop_time(j)
    sum_stops = sum_stops + stop_time(j)
    sum_stops_2 = sum_stops_2 + (stop_time(j) * stop_time(j))
  Next j
  mean_stop = sum_stops / n
  stabwn_stop = Sqr((n * sum_stops_2 - (sum_stops * sum_stops)) / (n * n))
End Sub


Sub min_max_mean_path() ' maximale, minimale und mittlere Laufstrecke der gesammt Tracks (path length)
  sum_path = 0
  sum_path_2 = 0
  min_path = 100
  max_path = 0
  n = k_max
  For k = 1 To k_max
    If path(k) > max_path Then max_path = path(k)
    If path(k) < min_path Then min_path = path(k)
    sum_path = sum_path + path(k)
    sum_path_2 = sum_path_2 + (path(k) * path(k))
  Next k
  mean_path = sum_path / n
  stabwn_path = Sqr((n * sum_path_2 - (sum_path * sum_path)) / (n * n))
End Sub

Sub ausgeben()

 a = 2
 b = 5

 Cells(a + 5, 7).Formula = "run length"
 For j = 1 To j_max - 1
   Cells(a + 5 + j, 6).Formula = j
   Cells(a + 5 + j, 7).Formula = run_length(j)
 Next j
 
 Cells(a + 5, 9).Formula = "path length"
 For k = 1 To k_max
   Cells(a + k + 5, 8).Formula = k
   Cells(a + k + 5, 9).Formula = path(k)
 Next k
 
 Cells(a + 5, 11).Formula = "stop length"
 For k = 1 To stops
   Cells(a + k + 5, 10).Formula = k
   Cells(a + k + 5, 11).Formula = stop_time(k)
 Next k
 
 Cells(a + 5, 13).Formula = "ds"
 Cells(a + 5, 14).Formula = "dv"
 Zaehler = 1
 For i = 1 To i_max - 1
   If ds(i) > 0 Then
      Cells(a + Zaehler + 5, 12).Formula = Zaehler
      Cells(a + Zaehler + 5, 13).Formula = ds(i)
      Cells(a + Zaehler + 5, 14).Formula = dv(i)
      Zaehler = Zaehler + 1
   End If
 Next i
   
 
 
 Cells(a + 1, b).Formula = "without ES = 0"
 Cells(a + 2, b).Formula = "with ES = 0"
 
 Cells(a, b + 1).Formula = "# of path"
 Cells(a, b + 2).Formula = "mean elm. step"
 Cells(a, b + 3).Formula = "SD"
 Cells(a, b + 4).Formula = " n "
 Cells(a, b + 5).Formula = "max elm. step"
 Cells(a, b + 6).Formula = "# of runs"
 Cells(a, b + 7).Formula = "mean run length"
 Cells(a, b + 8).Formula = "SD"
 Cells(a, b + 9).Formula = "mean stop length"
 Cells(a, b + 10).Formula = "SD"
 Cells(a, b + 11).Formula = "mean path length"
 Cells(a, b + 12).Formula = "SD"
 Cells(a, b + 13).Formula = "mean velocity"
 Cells(a, b + 14).Formula = "SD"
 Cells(a, b + 15).Formula = "max velocity"
 
 Cells(a + 1, b + 1).Formula = k_max
 Cells(a + 1, b + 2).Formula = mean_ds_b
 Cells(a + 1, b + 3).Formula = stabwn_ds_b
 Cells(a + 1, b + 4).Formula = Zaehler - 1
 Cells(a + 1, b + 5).Formula = max_ds
 Cells(a + 1, b + 6).Formula = j_max - 1
 Cells(a + 1, b + 7).Formula = mean_length
 Cells(a + 1, b + 8).Formula = stabwn_length
 Cells(a + 1, b + 9).Formula = mean_stop
 Cells(a + 1, b + 10).Formula = stabwn_stop
 Cells(a + 1, b + 11).Formula = mean_path
 Cells(a + 1, b + 12).Formula = stabwn_path
 Cells(a + 1, b + 13).Formula = mean_dv_b
 Cells(a + 1, b + 14).Formula = stabwn_dv_b
 Cells(a + 1, b + 15).Formula = max_dv
 
 Cells(a + 2, b + 1).Formula = k_max
 Cells(a + 2, b + 2).Formula = mean_ds
 Cells(a + 2, b + 3).Formula = stabwn_ds
 Cells(a + 2, b + 4).Formula = Zaehler - 1
 Cells(a + 2, b + 5).Formula = max_ds
 Cells(a + 2, b + 6).Formula = j_max - 1
 Cells(a + 2, b + 7).Formula = mean_length
 Cells(a + 2, b + 8).Formula = stabwn_length
 Cells(a + 2, b + 9).Formula = mean_stop
 Cells(a + 2, b + 10).Formula = stabwn_stop
 Cells(a + 2, b + 11).Formula = mean_path
 Cells(a + 2, b + 12).Formula = stabwn_path
 Cells(a + 2, b + 13).Formula = mean_dv
 Cells(a + 2, b + 14).Formula = stabwn_dv
 Cells(a + 2, b + 15).Formula = max_dv
 

 'Cells(i_max + j + 1, 5).Formula = "min length": Cells(i_max + j + 1, 6).Formula = min_length
 'Cells(i_max + j + 2, 5).Formula = "max length": Cells(i_max + j + 2, 6).Formula = max_length
 'Cells(i_max + j + 16, 5).Formula = "min ds": Cells(i_max + j + 16, 6).Formula = min_ds
 'Cells(i_max + j + 26, 5).Formula = "# of stops ": Cells(i_max + j + 26, 6).Formula = stops
 'Cells(i_max + j + 30, 5).Formula = "max stop length": Cells(i_max + j + 30, 6).Formula = max_stop
 'Cells(i_max + j + 15, 5).Formula = "mean dv mit 0": Cells(i_max + j + 15, 6).Formula = mean_dv
 'Cells(i_max + j + 16, 5).Formula = "stabwn": Cells(i_max + j + 16, 6).Formula = stabwn_dv
 'Cells(i_max + j + 10, 5).Formula = "mean ds mit 0": Cells(i_max + j + 10, 6).Formula = mean_ds
 'Cells(i_max + j + 11, 5).Formula = "stabwn": Cells(i_max + j + 11, 6).Formula = stabwn_ds
End Sub

Sub Tabelle()
    Range("G3:H4,J3:J4,L3:T4").Select
    Selection.NumberFormat = "0.00"
    Range("F2:T4").Select
    With Selection
        .HorizontalAlignment = xlCenter
        .VerticalAlignment = xlBottom
        .WrapText = False
        .Orientation = 0
        .AddIndent = False
        .IndentLevel = 0
        .ShrinkToFit = False
        .ReadingOrder = xlContext
        .MergeCells = False
    End With
    Range("F2:T2,E3:E4,E3:E4").Select
    Selection.Font.Bold = True
End Sub

Sub Tabellenrahmen()
    Range("E2:T4").Select
    Selection.Borders(xlDiagonalDown).LineStyle = xlNone
    Selection.Borders(xlDiagonalUp).LineStyle = xlNone
    With Selection.Borders(xlEdgeLeft)
        .LineStyle = xlContinuous
        .Weight = xlThin
        .ColorIndex = xlAutomatic
    End With
    With Selection.Borders(xlEdgeTop)
        .LineStyle = xlContinuous
        .Weight = xlThin
        .ColorIndex = xlAutomatic
    End With
    With Selection.Borders(xlEdgeBottom)
        .LineStyle = xlContinuous
        .Weight = xlThin
        .ColorIndex = xlAutomatic
    End With
    With Selection.Borders(xlEdgeRight)
        .LineStyle = xlContinuous
        .Weight = xlThin
        .ColorIndex = xlAutomatic
    End With
    With Selection.Borders(xlInsideVertical)
        .LineStyle = xlContinuous
        .Weight = xlThin
        .ColorIndex = xlAutomatic
    End With
    With Selection.Borders(xlInsideHorizontal)
        .LineStyle = xlContinuous
        .Weight = xlThin
        .ColorIndex = xlAutomatic
    End With
End Sub
Sub HP()
  init
  einlesen 1, 2, 3
  path_length
  min_max_mean_path
  runs_and_stops
  min_max_mean_run_length
  min_max_mean_stops
  min_max_mean_es
  ausgeben
  Tabelle
  Tabellenrahmen
End Sub
