Attribute VB_Name = "Programm"
'Programm zur stereologischen Analyse von Mikrotubuli im in vitro Testsystem
'Wolfstein et al., 2006,im Druck, Traffic

Dim i As Integer, j As Integer
Dim i_max As Integer, j_max As Integer
Dim grauwert(1000, 1000) As Single, dgrauwert As Single, schwelle As Single
Dim mt(1000, 1000) As Boolean
Dim gitterlinien_x As Integer, gitterlinien_y As Integer
Dim schritt As Integer, n As Integer
Dim j_mitte As Integer, i_mitte As Integer
Dim i_neu As Integer, j_neu As Integer
Dim r As Single, alpha As Single, dalpha As Single, winkel(20, 20) As Single
Dim di As Single, dj As Single
Dim pi As Single
Dim Zaehler As Integer, m As Integer, l As Integer, schleife As Integer
Dim schnittpunkte(20, 20) As Integer, expnr As Integer, datei As String, kammer As String
Dim ordner As Integer
Dim ordnername As String

Function arctan(arg)
Dim kerwert As Boolean
Dim k As Integer
Dim pi As Single
   pi = 3.141592654
   kerwert = False
   If arg > 1 Then
       arg = 1 / arg
       kerwert = True
   End If
   arctan = arg
   For k = 2 To 150
     arctan = arctan + ((-1) ^ (k - 1)) * (arg ^ (2 * k - 1)) / (2 * k - 1)
   Next k
   If kerwert = True Then arctan = pi / 2 - arctan
End Function

Sub einlesen()
  Zaehler = 0
  For i = 1 To i_max
     For j = 1 To j_max
       grauwert(i, j) = Cells(i, j).Formula
       mt(i, j) = False
     Next j
  Next i
End Sub

Sub schreiben()
  For i = 1 To i_max
    For j = 1 To j_max
       Cells(i, j).Formula = grauwert(i, j)
       mt_maxwerte
    Next j
  Next i
End Sub

Sub mtzeichnen()
   Cells(i, j).Select
   mt(i, j) = True
   Selection.Font.Bold = True
   Selection.Font.ColorIndex = 3
   Cells(i, j).Formula = grauwert(i, j)
End Sub

Sub mt_maxwerte()
   dgrauwert = 2
   If grauwert(i, j) > schwelle Then
     If grauwert(i + 1, j) + dgrauwert <= grauwert(i, j) Then
        If grauwert(i - 1, j) + dgrauwert <= grauwert(i, j) Then
           mtzeichnen
        End If
     End If
     If grauwert(i, j + 1) + dgrauwert <= grauwert(i, j) Then
        If grauwert(i, j - 1) + dgrauwert <= grauwert(i, j) Then
           mtzeichnen
        End If
     End If
   End If
End Sub
    
Sub gitterdrehen()
  i_neu = 0
  j_neu = 0
  i_mitte = CInt(i_max / 2)
  j_mitte = CInt(j_max / 2)
  di = i_mitte - i
  dj = j_mitte - j
  di = Sqr(di * di)
  dj = Sqr(dj * dj)
  r = Sqr(di * di + dj * dj)
  If dj <> 0 Then
    alpha = arctan(di / dj)
  End If
  If dj = 0 Then
    alpha = pi / 2
  End If
  If i < i_mitte And j < j_mitte Then
       alpha = alpha + dalpha
       di = Sin(alpha) * r
       dj = Cos(alpha) * r
       i_neu = CInt(i_mitte - di)
       j_neu = CInt(j_mitte - dj)
  End If
  
  If i < i_mitte And j > j_mitte Then
       alpha = alpha - dalpha
       di = Sin(alpha) * r
       dj = Cos(alpha) * r
       i_neu = CInt(i_mitte - di)
       j_neu = CInt(j_mitte + dj)
  End If
        
  If i > i_mitte And j > j_mitte Then
       alpha = alpha + dalpha
       di = Sin(alpha) * r
       dj = Cos(alpha) * r
       i_neu = CInt(i_mitte + di)
       j_neu = CInt(j_mitte + dj)
  End If
        
  If i > i_mitte And j < j_mitte Then
      alpha = alpha - dalpha
      di = Sin(alpha) * r
      dj = Cos(alpha) * r
      i_neu = CInt(i_mitte + di)
      j_neu = CInt(j_mitte - dj)
  End If
End Sub
    
Sub gitterzeichnen()
If i_neu > 0 And j_neu > 0 Then
   If i_neu <= i_max And j_neu <= j_max Then
       Cells(i_neu, j_neu).Select
       If mt(i_neu, j_neu) = True Then Zaehler = Zaehler + 1
   End If
End If
   With Selection.Interior
        .ColorIndex = 1
        .Pattern = xlSolid
   End With
End Sub

       
Sub stereogitter()
   gitterlinien_x = 5
   gitterlinien_y = 10
   dalpha = 0
   Randomize
   dalpha = Rnd * pi / 2
   ' Horiontal '
   schritt = 55
   j = -3 * schritt
   For n = 1 To gitterlinien_x + 10
     For i = -200 To i_max + 100
        gitterdrehen
        gitterzeichnen
     Next i
     j = j + schritt
    Next n
   ' Vertikal '
   schritt = 55
   i = -3 * schritt
   For n = 1 To gitterlinien_y + 10
     For j = -200 To j_max + 200
        gitterdrehen
        gitterzeichnen
     Next j
     i = i + schritt
    Next n
End Sub
Sub Tabelle()
   m = 3
   l = 0
   For l = 1 To 3
     For schleife = 1 To 3
        m = m + 1
        Cells(l + 1, 1).Formula = "Teil" & l
        Cells(1, 2 * schleife).Formula = "Winkel" & m
        Cells(1, 2 * schleife + 1).Formula = "Schnittpunkte"
        Cells(l + 1, 2 * schleife).Formula = winkel(l, m) & ""
        Cells(l + 1, 2 * schleife + 1).Formula = schnittpunkte(l, m)
     Next schleife
   Next l
End Sub

Sub HP()
 ordnername = "ordnername"
 pi = 3.141592654
 i_max = 582
 j_max = 256
 schwelle = 550
 For ordner = 1 To 1
   For expnr = 1 To 1
     datei = "mt" & expnr & ".xls"
     kammer = "kammer" & ordner
     Workbooks.Open FileName:= _
          "C:\" & ordnername & "\" & kammer & "\" & datei
     m = 3
     l = 0
     For l = 1 To 3
        Sheets("tabelle" & l).Select
        einlesen
        For schleife = 1 To 3
          m = m + 1
          Sheets.Add
          Sheets("tabelle" & m).Select
          schreiben
          stereogitter
          winkel(l, m) = dalpha * 180 / pi
          schnittpunkte(l, m) = Zaehler
          Zaehler = 0
        Next schleife
     Next l
     Sheets.Add
     Sheets("tabelle" & m + 1).Select
     Tabelle
     ActiveWorkbook.SaveAs FileName:= _
        "C:\" & ordnername & "\" & kammer & "\mt-Auswertung" & expnr & " " & schwelle & "_" & dgrauwert
     ActiveWorkbook.Close FileName:= _
        "C:\" & ordnername & "\" & kammer & "\mt-Auswertung" & expnr & " " & schwelle & "_" & dgrauwert
   Next expnr
 Next ordner
End Sub

